# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v45</h1>       <p>Introduced in Cloudera Manager 7.5.4</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.5.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiHBaseSnapshotError(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'table_name': 'str',
        'snapshot_name': 'str',
        'storage': 'Storage',
        'storage_location': 'str',
        'error': 'str'
    }

    attribute_map = {
        'table_name': 'tableName',
        'snapshot_name': 'snapshotName',
        'storage': 'storage',
        'storage_location': 'storageLocation',
        'error': 'error'
    }

    def __init__(self, table_name=None, snapshot_name=None, storage=None, storage_location=None, error=None):
        """
        ApiHBaseSnapshotError - a model defined in Swagger
        """

        self._table_name = None
        self._snapshot_name = None
        self._storage = None
        self._storage_location = None
        self._error = None

        if table_name is not None:
          self.table_name = table_name
        if snapshot_name is not None:
          self.snapshot_name = snapshot_name
        if storage is not None:
          self.storage = storage
        if storage_location is not None:
          self.storage_location = storage_location
        if error is not None:
          self.error = error

    @property
    def table_name(self):
        """
        Gets the table_name of this ApiHBaseSnapshotError.
        Name of the table.

        :return: The table_name of this ApiHBaseSnapshotError.
        :rtype: str
        """
        return self._table_name

    @table_name.setter
    def table_name(self, table_name):
        """
        Sets the table_name of this ApiHBaseSnapshotError.
        Name of the table.

        :param table_name: The table_name of this ApiHBaseSnapshotError.
        :type: str
        """

        self._table_name = table_name

    @property
    def snapshot_name(self):
        """
        Gets the snapshot_name of this ApiHBaseSnapshotError.
        Name of the snapshot.

        :return: The snapshot_name of this ApiHBaseSnapshotError.
        :rtype: str
        """
        return self._snapshot_name

    @snapshot_name.setter
    def snapshot_name(self, snapshot_name):
        """
        Sets the snapshot_name of this ApiHBaseSnapshotError.
        Name of the snapshot.

        :param snapshot_name: The snapshot_name of this ApiHBaseSnapshotError.
        :type: str
        """

        self._snapshot_name = snapshot_name

    @property
    def storage(self):
        """
        Gets the storage of this ApiHBaseSnapshotError.
        Whether the snapshot is local or remote.

        :return: The storage of this ApiHBaseSnapshotError.
        :rtype: Storage
        """
        return self._storage

    @storage.setter
    def storage(self, storage):
        """
        Sets the storage of this ApiHBaseSnapshotError.
        Whether the snapshot is local or remote.

        :param storage: The storage of this ApiHBaseSnapshotError.
        :type: Storage
        """

        self._storage = storage

    @property
    def storage_location(self):
        """
        Gets the storage_location of this ApiHBaseSnapshotError.
        The remote location where a snapshot is stored. /*  Optional - location comes from HBase service config if this is not defined

        :return: The storage_location of this ApiHBaseSnapshotError.
        :rtype: str
        """
        return self._storage_location

    @storage_location.setter
    def storage_location(self, storage_location):
        """
        Sets the storage_location of this ApiHBaseSnapshotError.
        The remote location where a snapshot is stored. /*  Optional - location comes from HBase service config if this is not defined

        :param storage_location: The storage_location of this ApiHBaseSnapshotError.
        :type: str
        """

        self._storage_location = storage_location

    @property
    def error(self):
        """
        Gets the error of this ApiHBaseSnapshotError.
        Description of the error.

        :return: The error of this ApiHBaseSnapshotError.
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """
        Sets the error of this ApiHBaseSnapshotError.
        Description of the error.

        :param error: The error of this ApiHBaseSnapshotError.
        :type: str
        """

        self._error = error

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiHBaseSnapshotError):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
