# (C) Datadog, Inc. 2024-present
# All rights reserved
# Licensed under a 3-clause BSD style license (see LICENSE)

METRIC_MAP = {
    'argo_workflows_count': 'current_workflows',
    'argo_workflows_error_count': 'error',
    'argo_workflows_k8s_request': 'k8s_request',
    'argo_workflows_operation_duration_seconds': 'operation_duration_seconds',
    'argo_workflows_pods_count': 'pods',
    'argo_workflows_queue_adds_count': 'queue_adds',
    'argo_workflows_queue_depth_count': 'queue_depth',
    'argo_workflows_queue_latency': 'queue_latency',
    'argo_workflows_workers_busy_count': 'workers_busy',
    'argo_workflows_workflow_condition': 'workflow_condition',
    'argo_workflows_workflows_processed_count': 'workflows_processed',
    'log_messages': 'log_messages',
    'go_gc_duration_seconds': 'go.gc.duration.seconds',
    'go_goroutines': 'go.goroutines',
    'go_info': "go.info",
    'go_memstats_alloc_bytes': {'name': 'go.memstats.alloc_bytes', 'type': 'native_dynamic'},
    'go_memstats_buck_hash_sys_bytes': 'go.memstats.buck_hash.sys_bytes',
    'go_memstats_frees': 'go.memstats.frees',
    'go_memstats_gc_sys_bytes': 'go.memstats.gc.sys_bytes',
    'go_memstats_heap_alloc_bytes': 'go.memstats.heap.alloc_bytes',
    'go_memstats_heap_idle_bytes': 'go.memstats.heap.idle_bytes',
    'go_memstats_heap_inuse_bytes': 'go.memstats.heap.inuse_bytes',
    'go_memstats_heap_objects': 'go.memstats.heap.objects',
    'go_memstats_heap_released_bytes': 'go.memstats.heap.released_bytes',
    'go_memstats_heap_sys_bytes': 'go.memstats.heap.sys_bytes',
    'go_memstats_lookups': 'go.memstats.lookups',
    'go_memstats_mallocs': 'go.memstats.mallocs',
    'go_memstats_mcache_inuse_bytes': 'go.memstats.mcache.inuse_bytes',
    'go_memstats_mcache_sys_bytes': 'go.memstats.mcache.sys_bytes',
    'go_memstats_mspan_inuse_bytes': 'go.memstats.mspan.inuse_bytes',
    'go_memstats_mspan_sys_bytes': 'go.memstats.mspan.sys_bytes',
    'go_memstats_next_gc_bytes': 'go.memstats.next.gc_bytes',
    'go_memstats_other_sys_bytes': 'go.memstats.other.sys_bytes',
    'go_memstats_stack_inuse_bytes': 'go.memstats.stack.inuse_bytes',
    'go_memstats_stack_sys_bytes': 'go.memstats.stack.sys_bytes',
    'go_memstats_sys_bytes': 'go.memstats.sys_bytes',
    'go_threads': 'go.threads',
}

# Metrics available in Argo Workflow v3.6+
V3_6_PLUS_METRICS = {
    'argo_workflows_cronworkflows_concurrencypolicy_triggered': 'cronworkflows.concurrencypolicy_triggered',
    'argo_workflows_cronworkflows_triggered': 'cronworkflows.triggered',
    'argo_workflows_deprecated_feature': 'deprecated.feature',
    'argo_workflows_gauge': 'current_workflows',
    'argo_workflows_is_leader': 'is_leader',
    'argo_workflows_k8s_request_duration': 'k8s_request.duration',
    'argo_workflows_log_messages': 'log_messages',
    'argo_workflows_pod_pending_count': 'pod.pending',
    'argo_workflows_pods_gauge': 'pods',
    'argo_workflows_pods_total_count': 'pods_total',
    'argo_workflows_queue_depth_gauge': 'queue_depth',
    'argo_workflows_queue_duration': 'queue.duration',
    'argo_workflows_queue_longest_running': 'queue.longest_running',
    'argo_workflows_queue_retries': 'queue.retries',
    'argo_workflows_queue_unfinished_work': 'queue.unfinished_work',
    'argo_workflows_total_count': 'total',
    'argo_workflows_version': 'version',
    'argo_workflows_workflowtemplate_runtime': 'workflowtemplate.runtime',
    'argo_workflows_workflowtemplate_triggered': 'workflowtemplate.triggered',
}
